<?php
/* 
   MasterSoft Software Solutions Ltd. - www.mastersoft.at - October. 2009 
   info@mastersoft.at
   This file is licensed under terms of the MPT Open License.
   You can find the license under http://www.mastersoft.at/content/view/26/34/lang,de/    
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.filesystem.file');

/**
 * the model class for a single video.
 * @author <a href="http://www.mastersoft.at" target="_blank">MasterSoft Software Solutions Ltd.</a>
 *
 */
class VideosModelVideo extends JModel
{	
	/**
	 * the data array for a video
	 * the array contains an array for each video of the structure:
	 * 0:  id
	 * 1:  title
	 * 2:  description
	 * 3:  position
	 * 4:  published
     * 5:  flvPath
	 * 6:  movPath
	 * 7:  thumbPath
	 * 8:  fkFlv
	 * 9:  fkMov
	 * 10: fkThumb
	 * 11: width
	 * 12: height
	 * @var array
	 */
	var $_data;
	
	/**
	 * Constructor that retrieves the ID from the request	 	 
	 * @return	void
	 */
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);		
	}

	
	/**
	 * Method to set the video identifier		
	 * @param	int video identifier
	 * @return	void
	 */
	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	/**
	 * Method to get a video
	 * @return the data array
	 */
	function &getData()
	{		
		// Load the data
		if (empty( $this->_data ) || !isset($this->_data)) 
		{
			$this->_data = array();	
			
			$query = ' SELECT * FROM #__msVideo '.
					'  WHERE msv_id = '.$this->_id;
			
			
			$this->_db->setQuery( $query );
			$result = $this->_db->loadRow();

			if($result)
			{
				$id =  $result[0];
				$title =  $result[1];
				$fkFlv =  $result[2];
				$fkMov =  $result[3];
				$fkThumb =  $result[4];
				$description =  $result[5];
				$position =  $result[6];
				$published =  $result[7];
				$width =  $result[8];
				$height =  $result[9];
				
				$flvPath = "";
				$movPath = "";
				$thumbPath = "";
				
				$query = "SELECT msvf_path,msvf_type FROM #__msFiles ".
						 "WHERE msvf_id = " .$fkFlv . " OR msvf_id = " .$fkMov . " OR msvf_id = ".$fkThumb;
				
				$this->_db->setQuery( $query );
				$files = $this->_db->loadRowList();
				
				foreach($files as $file)
				{
					if($file[1] == "flash")
						$flvPath = JFile::getName($file[0]);
					else if($file[1] == "mov")
						$movPath = JFile::getName($file[0]);
					else if($file[1] == "thumb")
						$thumbPath = JFile::getName($file[0]);
				}
				
				array_push($this->_data,$id);
				array_push($this->_data,$title);
				array_push($this->_data,$description);
				array_push($this->_data,$position);
				array_push($this->_data,$published);
				array_push($this->_data,$flvPath);
				array_push($this->_data,$movPath);
				array_push($this->_data,$thumbPath);
				array_push($this->_data,$fkFlv);
				array_push($this->_data,$fkMov);
				array_push($this->_data,$fkThumb);
				array_push($this->_data,$width);
				array_push($this->_data,$height);
			}
		}		
		
		return $this->_data;
	}
	
	/**
	 * returns an array with all file names and ids of the flash,quicktime and thumb files
	 * @return array:
	 */
	function &getFileNames()
	{		
		$files = array();		
		$flashArray = array();
		$movArray = array();
		$thumbArray = array();
				
		$sqlQuery = "select msvf_path,msvf_type,msvf_id from #__msFiles";
    	$db	= JFactory::getDBO();
    	    					
    	$db->setQuery( $sqlQuery );

		if ($result = $db->query()) 
		{
			$rows = $db->loadRowList();
			foreach($rows as $row)
			{								
				$path = $row[0];
				$name = JFile::getName($path);				
				$type = $row[1];	
				$id = $row[2];							
				
				if($type == "flash")
				{					
					array_push($flashArray,array($name,$id));										
				}
				else if($type == "mov")	
				{															
					array_push($movArray,array($name,$id));
				}
				else if($type == "thumb")
				{										
					array_push($thumbArray,array($name,$id));
				}
			}
		}
		
		array_push($files,$flashArray);
		array_push($files,$movArray);
		array_push($files,$thumbArray);
		
		return $files;
	}

	
	/**
	 * Method to store a video	 	
	 * @return	string	a success or an error message
	 */
	function store()
	{		
		
		$id = JRequest::getVar('id');		
		$title = JRequest::getVar('title');
		$published = JRequest::getVar('published');
		$description = JRequest::getVar('description');
		$flashfile = JRequest::getVar('flashfile');
		$movfile = JRequest::getVar('movfile');
		$thumbfile = JRequest::getVar('thumbfile');
		$width = JRequest::getVar('width');
		$height = JRequest::getVar('height');

		$sql;
		$db	= JFactory::getDBO();
		
		$positionQuery = "(select (max(msv_position)+1) from  #__msVideo)";
		$db->setQuery( $positionQuery );
		$db->query();
		$row = $db->loadRow();
		$position = $row[0];
		
		if(!isset($position) || strlen($position) <= 0 )
			$position = "0";
				
		if($id == "-1")
		{
			//new video
			$sql = "insert into #__msVideo " 
				   ."(msv_title,msv_fk_flvPath,msv_fk_movPath,msv_fk_thumbPath,msv_description,msv_position,msv_published,msv_width,msv_height) "
				   ."VALUES('" .$title ."'," .$flashfile ."," .$movfile ."," .$thumbfile .",'" .$description ."'," .$position ."," .$published ."," .$width ."," .$height .")";
			
	    	$db->setQuery( $sql );	    	
			$db->query(); 
		}
		else
		{
			//update video
			//new video
			$sql = "update #__msVideo " 
				   ." SET "
				   ."msv_title = '" .$title ."',"
				   ."msv_fk_flvPath = " .$flashfile .","
				   ."msv_fk_movPath = " .$movfile .","
				   ."msv_fk_thumbPath = " .$thumbfile .","
				   ."msv_description = '" .$description ."',"				  
				   ."msv_published = " .$published .","
				   ."msv_width = " .$width .","
				   ."msv_height = " .$height
				   ." WHERE msv_id= " .$id;
				    
				   			
			
	    	$db->setQuery( $sql );
			$db->query();
		}
		
		//$msg = $sql;
		$msg = "video successfully stored!";
		return $msg;
	}

	
	/**
	 * Method to delete video(s)	 	
	 * @return	string	a success or error message
	 */
	function delete()
	{		
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );		

		$db	= JFactory::getDBO();
		$sql = "delete from #__msVideo WHERE ";			   
		
		for($i = 0;$i < count($cids);$i++ ) 
		{
			if($i < (count($cids)-1) )
				$sql .= "msv_id = " .$cids[$i] ." OR ";
			else
				$sql .= "msv_id = " .$cids[$i];							   							    	 
		}						
		
		$db->setQuery( $sql );	    	
		$db->query();
		
		return "Video(s) deleted!";
	}		
}
?>
